local PrincessTower = ...

-- Register common prefab nodes
PrincessTower:registerAssetId("models/princessTower.fbx/Prefab/princessTower/RootPart", "PRINCESS_TOWER_ROOT_PREFAB")
PrincessTower:registerAssetId("models/princessTower.fbx/Prefab/princessTower/RootPart/DoorPart", "PRINCESS_TOWER_DOOR_PREFAB")

-- Register the princess tower part
PrincessTower:register({
	DataType = "BUILDING_PART",
	Id = "PRINCESS_TOWER_ROOT_PART",
	Name = "PRINCESS_TOWER_ROOT_NAME",
	Description = "PRINCESS_TOWER_ROOT_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PRINCESS_TOWER_ROOT_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 5 }
		}
	},
	AssetBuildingFunction = "PRINCESS_TOWER_ROOT"
})
PrincessTower:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = "PRINCESS_TOWER_ROOT",
		WorkerCapacity = 1,
                RelatedJob = { Job = "PRINCESS", Behavior = "WORK_BEHAVIOR" }
})

-- Register the stone gate set door part
PrincessTower:register({
	DataType = "BUILDING_PART",
	Id = "PRINCESS_TOWER_DOOR_PART",
	Name = "PRINCESS_TOWER_DOOR_NAME",
	Description = "PRINCESS_TOWER_DOOR_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PRINCESS_TOWER_DOOR_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Override building part components properties (generated by the building asset processor) to add building zones

PrincessTower:registerPrefabComponent("models/princessTower.fbx/Prefab/princessTower/RootPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 4 }
})

-- Register flag assigner component on the collider's type to 'PLATFORM'

PrincessTower:configurePrefabFlagList("models/princessTower.fbx/Prefab/princessTower/RootPart", { "PLATFORM" })

-- Register grounding components

PrincessTower:registerPrefabComponent("models/princessTower.fbx/Prefab/princessTower/RootPart/DoorPart", {
	DataType = "COMP_GROUNDED"
})

PrincessTower:registerPrefabComponent("models/princessTower.fbx/Prefab/princessTower/RootPart/DoorPart", {
	DataType = "COMP_BUILDING_PART",
--	BuildingPartType = "DOOR", -- Allows the door to be used as entrance
	HasBuildingZone = true,
	BuildingZone = { 1, 1 }
})

-- Register air vent particle system (rope)

PrincessTower:registerAssetId("models/princessTower.fbx/Prefab/princessTower/RootPart/RopeEmitter", "PRINCESS_TOWER_ROPE_EMITTER_PREFAB")

PrincessTower:registerPrefabComponent("models/princessTower.fbx/Prefab/princessTower/RootPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { "PRINCESS_TOWER_ROPE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

PrincessTower:registerPrefabComponent("models/princessTower.fbx/Prefab/princessTower/RootPart/RopeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "ROPE_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = false
})

PrincessTower:registerPrefabComponent("models/princessTower.fbx/Prefab/princessTower/RootPart/RopeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})
